/* DC.C */
/* decoder */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <malloc.h>
#include "dc.h"
#include "stat_ini.h"

int MakeDecodeTable(int cpFrom,int cpTo,int Decodetable[256]);
int DeCode(char FnameFrom[], char FnameTo[]);

char E_Path[_MAX_PATH],E_Fname[_MAX_FNAME],E_drive[_MAX_DRIVE],E_dir[_MAX_DIR],E_ext[_MAX_EXT];
char *ProgName;

char *sMode;
char sModecodes[]="DWKMI?";
int CodePageFrom=0;
int CodePageTo  =1;
int UnixMode=0;
int DecodeTable[256];

char *Head[]=
{ "Universal Russian codepage DeCoder v 0.3 light",
  "(c)Evgeny Kotsuba, 1997"
};


int main(int n, char *par[])
{   int i,l;
    char ch;
    ProgName = par[0];

    printf("\n%s\n%s",Head[0],Head[1]);

   _splitpath(ProgName,E_drive,E_dir,E_Fname,E_ext);
   _makepath(Proj.fname,E_drive,E_dir,E_Fname,"ini");

    ReadProject(&Proj);

    if(n < 4)
    {EXi:
       printf("\nusage: dc.exe mode fileFrom fileTo");
       printf("\nmode: CodepageFrom+CodepageTo+[Unix text mode]");
       printf("\n\tCodepage: D(os)|K(oi8)|W(in)|M(ac)|I(so)");
       printf("\n\tUnix text mode: U");
       printf("\nDecoding examples:");
       printf("\nDos to Koi8:               dc.exe DK  textDos.txt TextKoi.txt");
       printf("\nWin to Koi8 and unix text mode: dc.exe WKU textWin.txt TextKoi.txt");
//       printf("\nUnknown to Dos (for OS/2 only): dc.exe ?D  text.txt    TextDos.txt");
       exit(1);
    }

    l = strlen(par[1]);
    if(l > 3) goto EXi;
    sMode = par[1];
    for(i=0;i<5;i++)
    {   ch = toupper(sMode[0]);
       if(ch == sModecodes[i])
               CodePageFrom = i;
       ch = toupper(sMode[1]);
       if(ch == sModecodes[i])
                CodePageTo = i;
    }
    if(CodePageTo == CodePageFrom) goto EXi;
    if(l>2)
    {    ch = toupper(sMode[2]);
       if(ch == 'U')
               UnixMode=1;
    }

    MakeDecodeTable(CodePageFrom,CodePageTo, DecodeTable);

    DeCode(par[2],par[3]);
    return 0;
}

/*******************************************************/
/* uncomment  for update stat_ini.h  */
/*
int projwrite(void);

int main(int n, char *par[])
{   int i,l;
    char ch;
    ProgName = par[0];
    strcpy(Proj.fname,"dc.ini");
    ReadProject(&Proj);
 projwrite();
}


int projwrite(void)
{  FILE *fp;
   int i,j,n;

   fp=fopen("proj.hh","w");
   fprintf(fp,"struct Project Proj = {\n");
   fprintf(fp,"%s,\n%i,",Proj.fname,Proj.n);
   for(n=0;n<5;n++)
   {
      for(j=0;j<8;j++)
      {   for(i=0;i<32;i++) fprintf(fp,"%i,", Proj.page[n].tab[j*32+i]);
          fprintf(fp,"\n");
      }
      fprintf(fp,"%s\n\n",Proj.page[n].name);
   }
   fprintf(fp,"};\n");

   fclose(fp);

   return 0;
}

*/

/*******************************************************/

int DeCode(char FnameFrom[], char FnameTo[])
{  FILE *fp, *fpto;
   int rc;
   long int l,lto;
   unsigned char ch,chcr;

   fp = fopen(FnameFrom,"rb");
   if(fp == NULL)
   {  gr_error(2,0,FnameFrom);
      exit(1);
   }
   fpto = fopen(FnameTo,"wb");
   if(fpto == NULL)
   {  gr_error(3,0,FnameTo);
      exit(1);
   }
   lto = 0;
   for(l=0;;l++)
   {
      rc=fread(&ch,1,1,fp);
      if(rc != 1) break;

      if(ch >= 128)
      {   ch = DecodeTable[ch];
      } else if(ch == 0xd) {
         if(0 == UnixMode)
         {   fwrite(&ch,1,1,fpto);
             lto++;
         }
         rc=fread(&ch,1,1,fp);
         l++;
         if(rc != 1) break;
      } else if(ch == 0xa) {
         if(0 == UnixMode)
         {  chcr = 0xd;
            fwrite(&chcr,1,1,fpto);
            lto++;
         }
      }

      fwrite(&ch,1,1,fpto);
      lto++;
   }
   printf("\n%li bytes read, %li bytes write\nOk",l,lto);
   fclose(fp);
   fclose(fpto);
   return 0;
}

int MakeDecodeTable(int cpFrom,int cpTo,int Decodetable[256])
{
    int i,j,k,ind;

    for(i=0; i<256; i++) DecodeTable[i]=i;

    for(i=128; i<256;i++)
    {   k = Proj.page[cpFrom].tab[i];
       ind = i;
       if(k != (int)'?')
       {  for(j=128;j<256;j++)
          {  if(k ==  Proj.page[cpTo].tab[j])
             {   ind = j;
                 break;
             }
          }
       }
       Decodetable[i]=ind;
    }
    return 0;

}

int gr_error(int Number,int Mode, char str[])
{  printf("\n");
   if(!Mode)
      printf("Error #%i ",Number);
   printf("%s ",str);
   return 1;
}
