/* dc_ini.c */
/* ⥭   ini */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "dc.h"

int StringINIanalize(char *str,struct Project *Proj);
char *IsINIstrSect(char *str);


static int INIsection=0;


int ReadProject(struct Project *Proj)
{  FILE *fp;
static char str[128],*s1,*s2;
   int rc,l;

   fp = fopen(Proj->fname,"r");
   if(fp == NULL)
    {   gr_error(1,0,Proj->fname);
       return -1;  /* ⠪ 䠩  */
    }
    Proj->n = -1;
    INIsection = 0;
   do
   {
      if(!fgets(str,128,fp)) break;
      l = strlen(str);
      if(l && str[l-1] == '\n') str[l-1]=0;
/* if it is comment or free string  - cotinue; */
      if(strlen(str) && !strchr(str,(int)';') )
      {     rc = StringINIanalize(str,Proj);
           if(rc == 1)
           {   sprintf(str,"襭   %s",Proj->fname);
               gr_error(0,0,str);
               exit(1);  /* ⠪ 䠩  */
           }

      }

    } while( !feof(fp) && !ferror(fp) );

    fclose(fp);
    return Proj->n;
}

/* Service for ReadProject */
int StringINIanalize(char *str,struct Project *Proj)
{   char *s, *s1,Pname[80], *sp;
    int i,j,np,raz,n,l,layerN;
    float WaitT, Vel;
    unsigned char ch;

    s = IsINIstrSect(str);
    if(INIsection == 0  && s == NULL)
           return 1;
    if(s)
    {   if  (!strcmpi(s,"CODENAME")) INIsection = 1;
       else if(!strcmpi(s,"CODEPAGE"))
       {    INIsection = 2;
       }  else INIsection = 0;
       return 0;
    }

    s1 = strchr(str,(int)'=');
    if(s1)
    {    *s1=0;
        s1++;
    }
/* Analizing Parametr name */
    if(INIsection ==  1)
    {
/* Parameter Name */
    sscanf(str,"%s",Pname);
    Proj->n++;
    if(Proj->n >= MAX_CODEPAGES)
    {   gr_error(40,0,0);
       exit(1);
    }
    strcpy(Proj->page[Proj->n].name,str);
    } else if(INIsection ==  2) {
/* Parameter value */
       for(i=0;i<8;i++)
       {   for(j=0;j<7;j++)  Pname[j] = str[i*7+j];
           Pname[j]=0;
           ch = '?';
           l = sscanf(Pname,"%i %c",&n,&ch);
           if(ch == 0) ch = '?';
           if(n > 0 && n < 256)
               Proj->page[Proj->n].tab[n] = ch;
       }
    }
    return 0;
}

char *IsINIstrSect(char *str)
{    char *s1, *s2;
     s1 = strchr(str,(int)'[');
     s2 = strchr(str,(int)']');
     if(s1 && s2)
     {   *s2 = 0;
        s1++;
        return s1;
     } else return NULL;
}

